#define _USE_MATH_DEFINES
#include <bits/stdc++.h>
using namespace std;
using ul = unsigned long long;
using ll = long long;
using ld = long double;
using pll = pair<ll,ll>;
#define in(v,c) ((c).find(v) != (c).end())
#define F(i,n) for(ll i = 0; i < (n); i++)
#define Fun(i,n) for(ul i = 0; i < (n); i++)
#ifdef GPD
template<class F>void lerr(F&&f){cerr<<forward<F>(f)<<endl;}
template<class F,class...R>void lerr(F&&f,R&&...r){cerr<<forward<F>(f)<<' ';lerr(forward<R>(r)...);}
#else
#define lerr(...)
#endif

const ll mod = 10e9+7;
struct Mod {
    ll x;
    Mod(ll xx): x(xx) {}
    Mod(): x(-1){}
    Mod operator+(Mod b)const {return Mod((x+b.x)%mod);}
    Mod operator-(Mod b)const{return Mod((x-b.x+mod)% mod);}
    Mod operator*(Mod b)const{return Mod((x*b.x)%mod);}
    Mod operator^(ll e)const {
        if(!e) return Mod(1);
        Mod r = *this^(e/2); r = r*r;
        return e&1 ? *this * r : r;
    }
    bool operator == (Mod b){
        return x == b.x;
    }
    bool operator != (Mod b){
        return  x != b.x;
    }
};


ll K, N;
Mod DP[64][70][70];
Mod DP_fixed[64][70][70];

Mod ACC[70][70];

void set_DP(){
    ll k = K+1;
    F(a, 64){
        F(b, k){
            F(c, k){
                DP[a][b][c] = -1;
                DP_fixed[a][b][c] = -1; 
            }
        }
    }
    F(b, k){
        F(c, k){
            ACC[b][c] = 0;
        }
    }
}

Mod frec(ll start, ll end, ll len_exp);

Mod frec_fixed(ll prev_end, ll my_end, ll len_exp ){
    if(len_exp == 0){
        if(__gcd(prev_end, my_end) == 1){
            return 1;
        } else{
            return 0;
        }
    }
    if(DP_fixed[prev_end][my_end][len_exp] != -1){
        return DP_fixed[prev_end][my_end][len_exp];
    }
    Mod sum = 0;
    for(ll my_star = 1; my_star <= K; ++my_star){
        if(__gcd(prev_end, my_star) == 1){
            Mod startsum = frec(my_star, my_end, len_exp);
            sum = sum + startsum;
        }
    }
    DP_fixed[prev_end][my_end][len_exp] = sum;
    return sum;
}

Mod frec(ll start, ll end, ll len_exp){
    if(len_exp == 0){
        throw;
    }
    if(len_exp == 1){
        return __gcd(start, end) == 1 ? 1 : 0;
    }
    lerr(start, end, len_exp);
    if(DP[len_exp][start][end] != -1){
        return DP[len_exp][start][end];
    }
    Mod sum = 0;
    for(int p = 1; p <= K; ++p){
        Mod left = frec(start, p, len_exp-1);
        Mod right = frec_fixed(p, end, len_exp-1);
        Mod onepsum = left*right;
        sum = sum + onepsum;
    }
    DP[len_exp][start][end] = sum;
    return sum;
}



int main(int argc, char const *argv[]) {
    cin.tie(0)->sync_with_stdio(0); cin.exceptions(cin.failbit);
    cout << setprecision(9) << fixed; lerr("ready");

    cin >> K >> N;
    if(N == 0){
        cout << K << endl;
        return 0;
    }
    set_DP();

    ll left_exp = log2l(N);
    N -= 1 << left_exp;
    lerr(left_exp, N);
    for(ll start = 1; start <= K; ++start){
        for(ll end = 1; end <= K; ++end){
            ACC[start][end] = frec(start, end, left_exp);
        }
    }
    while(N > 0){
        left_exp = log2l(N);
        N -= 1 << left_exp;
        lerr(left_exp, N);
        for(ll start = 1; start <= K; ++start){
            for(ll end = 1; end <= K; ++end){
                Mod sum = 0;
                for(ll p = 1; p <= K; ++p){
                    Mod onepsum = ACC[start][p] * frec_fixed(p, end, left_exp);
                    sum = sum + onepsum; 
                }
                ACC[start][end] = sum;
            }
        }

    }

    Mod sum = 0;
    for(ll start = 1; start <= K; ++start){
        for(ll end = 1; end <= K; ++end){
            sum = sum + ACC[start][end];
        }
    }
    cout << sum.x << endl;
    // ll l = 0;
    // F(i, k)
    //     F(j, k)
    //         if(__gcd(i+1, j+1) == 1) {
    //             lerr("ok", i+1,j+1);
    //             l++;
    //         }

    // lerr("l", l, "wrong", k*k-l);

    // Mod lm(l);
    // Mod res = (lm^(n/2));
    // if(n > 2)
    //     res = res - (Mod(k*k-l)^((n-1)/2));

    // cout << res.x << endl;

    return 0;
}

// ready
// 3 4
// ok 1 1
// ok 1 2
// ok 1 3
// ok 2 1
// ok 2 3
// ok 3 1
// ok 3 2
// l 7 wrong 2
// 47

